Index: tags/Visualization_after-vis09-02-01-tag/test/include/BuildCalorimeter.hh
===================================================================
--- trunk/source/visualization/test/include/BuildCalorimeter.hh	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/include/BuildCalorimeter.hh	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: BuildCalorimeter.hh,v 1.4 2006/06/29 21:33:34 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/include/BuildGeom_Example1.hh
===================================================================
--- trunk/source/visualization/test/include/BuildGeom_Example1.hh	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/include/BuildGeom_Example1.hh	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: BuildGeom_Example1.hh,v 1.4 2006/06/29 21:33:36 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/include/BuildGeom_Example2.hh
===================================================================
--- trunk/source/visualization/test/include/BuildGeom_Example2.hh	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/include/BuildGeom_Example2.hh	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: BuildGeom_Example2.hh,v 1.4 2006/06/29 21:33:38 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/include/BuildHouse.hh
===================================================================
--- trunk/source/visualization/test/include/BuildHouse.hh	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/include/BuildHouse.hh	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: BuildHouse.hh,v 1.2 2006/06/29 21:33:40 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/include/BuildParametrised.hh
===================================================================
--- trunk/source/visualization/test/include/BuildParametrised.hh	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/include/BuildParametrised.hh	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: BuildParametrised.hh,v 1.4 2006/06/29 21:33:42 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/include/BuildShapes.hh
===================================================================
--- trunk/source/visualization/test/include/BuildShapes.hh	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/include/BuildShapes.hh	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: BuildShapes.hh,v 1.4 2006/06/29 21:33:44 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/include/G4ParametrizedBox.hh
===================================================================
--- trunk/source/visualization/test/include/G4ParametrizedBox.hh	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/include/G4ParametrizedBox.hh	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ParametrizedBox.hh,v 1.4 2006/06/29 21:33:46 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/include/MyDetectorConstruction.hh
===================================================================
--- trunk/source/visualization/test/include/MyDetectorConstruction.hh	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/include/MyDetectorConstruction.hh	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: MyDetectorConstruction.hh,v 1.6 2006/06/29 21:33:48 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 
Index: tags/Visualization_after-vis09-02-01-tag/test/include/MyDetectorMessenger.hh
===================================================================
--- trunk/source/visualization/test/include/MyDetectorMessenger.hh	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/include/MyDetectorMessenger.hh	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: MyDetectorMessenger.hh,v 1.4 2006/06/29 21:33:50 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 
Index: tags/Visualization_after-vis09-02-01-tag/test/include/MyEventAction.hh
===================================================================
--- trunk/source/visualization/test/include/MyEventAction.hh	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/include/MyEventAction.hh	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: MyEventAction.hh,v 1.6 2006/11/01 11:16:23 allison Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 
Index: tags/Visualization_after-vis09-02-01-tag/test/include/MyPhysicsList.hh
===================================================================
--- trunk/source/visualization/test/include/MyPhysicsList.hh	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/include/MyPhysicsList.hh	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: MyPhysicsList.hh,v 1.5 2006/06/29 21:33:54 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/include/MyPrimaryGeneratorAction.hh
===================================================================
--- trunk/source/visualization/test/include/MyPrimaryGeneratorAction.hh	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/include/MyPrimaryGeneratorAction.hh	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: MyPrimaryGeneratorAction.hh,v 1.6 2006/06/29 21:33:56 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 
Index: tags/Visualization_after-vis09-02-01-tag/test/include/MyRunAction.hh
===================================================================
--- trunk/source/visualization/test/include/MyRunAction.hh	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/include/MyRunAction.hh	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: MyRunAction.hh,v 1.6 2006/06/29 21:33:58 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 
Index: tags/Visualization_after-vis09-02-01-tag/test/include/MySteppingAction.hh
===================================================================
--- trunk/source/visualization/test/include/MySteppingAction.hh	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/include/MySteppingAction.hh	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: MySteppingAction.hh,v 1.6 2006/06/29 21:34:00 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/include/ParametrisedBox.hh
===================================================================
--- trunk/source/visualization/test/include/ParametrisedBox.hh	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/include/ParametrisedBox.hh	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: ParametrisedBox.hh,v 1.5 2006/06/29 21:34:02 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/include/test19DetectorConstruction.hh
===================================================================
--- trunk/source/visualization/test/include/test19DetectorConstruction.hh	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/include/test19DetectorConstruction.hh	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: test19DetectorConstruction.hh,v 1.4 2006/06/29 21:34:06 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/include/test19DetectorMessenger.hh
===================================================================
--- trunk/source/visualization/test/include/test19DetectorMessenger.hh	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/include/test19DetectorMessenger.hh	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: test19DetectorMessenger.hh,v 1.4 2006/06/29 21:34:08 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/src/BuildCalorimeter.cc
===================================================================
--- trunk/source/visualization/test/src/BuildCalorimeter.cc	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/src/BuildCalorimeter.cc	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: BuildCalorimeter.cc,v 1.5 2006/06/29 21:34:10 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/src/BuildGeom_Example1.cc
===================================================================
--- trunk/source/visualization/test/src/BuildGeom_Example1.cc	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/src/BuildGeom_Example1.cc	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: BuildGeom_Example1.cc,v 1.6 2006/06/29 21:34:12 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/src/BuildGeom_Example2.cc
===================================================================
--- trunk/source/visualization/test/src/BuildGeom_Example2.cc	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/src/BuildGeom_Example2.cc	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: BuildGeom_Example2.cc,v 1.6 2006/06/29 21:34:14 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/src/BuildHouse.cc
===================================================================
--- trunk/source/visualization/test/src/BuildHouse.cc	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/src/BuildHouse.cc	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: BuildHouse.cc,v 1.3 2006/06/29 21:34:16 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/src/BuildParametrised.cc
===================================================================
--- trunk/source/visualization/test/src/BuildParametrised.cc	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/src/BuildParametrised.cc	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: BuildParametrised.cc,v 1.7 2006/06/29 21:34:18 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/src/BuildShapes.cc
===================================================================
--- trunk/source/visualization/test/src/BuildShapes.cc	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/src/BuildShapes.cc	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: BuildShapes.cc,v 1.6 2006/06/29 21:34:20 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/src/MyDetectorConstruction.cc
===================================================================
--- trunk/source/visualization/test/src/MyDetectorConstruction.cc	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/src/MyDetectorConstruction.cc	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: MyDetectorConstruction.cc,v 1.39 2006/11/14 16:03:55 allison Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/src/MyDetectorMessenger.cc
===================================================================
--- trunk/source/visualization/test/src/MyDetectorMessenger.cc	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/src/MyDetectorMessenger.cc	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: MyDetectorMessenger.cc,v 1.4 2006/06/29 21:34:24 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 
Index: tags/Visualization_after-vis09-02-01-tag/test/src/MyEventAction.cc
===================================================================
--- trunk/source/visualization/test/src/MyEventAction.cc	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/src/MyEventAction.cc	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: MyEventAction.cc,v 1.18 2008/04/04 14:01:14 allison Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 
Index: tags/Visualization_after-vis09-02-01-tag/test/src/MyPhysicsList.cc
===================================================================
--- trunk/source/visualization/test/src/MyPhysicsList.cc	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/src/MyPhysicsList.cc	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: MyPhysicsList.cc,v 1.8 2006/06/29 21:34:28 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/src/MyPrimaryGeneratorAction.cc
===================================================================
--- trunk/source/visualization/test/src/MyPrimaryGeneratorAction.cc	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/src/MyPrimaryGeneratorAction.cc	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: MyPrimaryGeneratorAction.cc,v 1.6 2006/06/29 21:34:30 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 
Index: tags/Visualization_after-vis09-02-01-tag/test/src/MyRunAction.cc
===================================================================
--- trunk/source/visualization/test/src/MyRunAction.cc	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/src/MyRunAction.cc	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: MyRunAction.cc,v 1.8 2006/06/29 21:34:32 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 
Index: tags/Visualization_after-vis09-02-01-tag/test/src/MySteppingAction.cc
===================================================================
--- trunk/source/visualization/test/src/MySteppingAction.cc	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/src/MySteppingAction.cc	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: MySteppingAction.cc,v 1.16 2006/06/29 21:34:34 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/src/ParametrisedBox.cc
===================================================================
--- trunk/source/visualization/test/src/ParametrisedBox.cc	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/src/ParametrisedBox.cc	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: ParametrisedBox.cc,v 1.6 2006/06/29 21:34:36 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/src/test19DetectorConstruction.cc
===================================================================
--- trunk/source/visualization/test/src/test19DetectorConstruction.cc	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/src/test19DetectorConstruction.cc	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: test19DetectorConstruction.cc,v 1.4 2006/06/29 21:34:40 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/src/test19DetectorMessenger.cc
===================================================================
--- trunk/source/visualization/test/src/test19DetectorMessenger.cc	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/src/test19DetectorMessenger.cc	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: test19DetectorMessenger.cc,v 1.8 2006/06/29 21:34:42 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/test19.cc
===================================================================
--- trunk/source/visualization/test/test19.cc	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/test19.cc	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: test19.cc,v 1.29 2007/01/05 16:00:48 allison Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: tags/Visualization_after-vis09-02-01-tag/test/testshapes.cc
===================================================================
--- trunk/source/visualization/test/testshapes.cc	(revision 952)
+++ tags/Visualization_after-vis09-02-01-tag/test/testshapes.cc	(revision 958)
@@ -26,5 +26,5 @@
 //
 // $Id: testshapes.cc,v 1.4 2006/06/29 21:33:32 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-03 $
+// GEANT4 tag $Name:  $
 //
 // 