Index: /trunk/source/visualization/OpenGL/History
===================================================================
--- /trunk/source/visualization/OpenGL/History	(revision 969)
+++ /trunk/source/visualization/OpenGL/History	(revision 970)
@@ -20,4 +20,7 @@
 History file for visualization/OpenGL
 -------------------------------------
+
+6th April 2009, Laurent Garnier
+ - G4OpenGLBitmapStore.hh : BugFix correction for windows.
 
 24th March 2009, Laurent Garnier (opengl-V09-02-01)
Index: /trunk/source/visualization/OpenGL/include/G4OpenGLBitMapStore.hh
===================================================================
--- /trunk/source/visualization/OpenGL/include/G4OpenGLBitMapStore.hh	(revision 969)
+++ /trunk/source/visualization/OpenGL/include/G4OpenGLBitMapStore.hh	(revision 970)
@@ -48,4 +48,5 @@
 #include <map>
 
+#include "G4OpenGL.hh"
 #include <GL/gl.h>
 #include <GL/glu.h>
@@ -79,2 +80,117 @@
 
 #endif
+svn add      electromagnetic/standard/src/G4WentzelVIModel.cc;
+svn add      electromagnetic/standard/src/G4UrbanMscModel2.cc;
+svn add      electromagnetic/standard/src/G4eMultipleScattering.cc;
+svn add      electromagnetic/standard/src/G4eBremsstrahlungRelModel.cc;
+svn add      electromagnetic/utils/src/G4EmSaturation.cc;
+svn add      electromagnetic/utils/src/G4EmConfigurator.cc;
+svn add      electromagnetic/utils/src/G4VMscModel.cc;
+svn add      electromagnetic/utils/src/G4EmElementSelector.cc;
+svn add      electromagnetic/utils/src/G4ElectronIonPair.cc;
+svn add      electromagnetic/highenergy/src/G4eeToPGammaModel.cc;
+svn add      electromagnetic/highenergy/src/G4ee2KNeutralModel.cc;
+svn add      electromagnetic/highenergy/src/G4hBremsstrahlung.cc;
+svn add      electromagnetic/highenergy/src/G4hPairProduction.cc;
+svn add      electromagnetic/highenergy/src/G4ee2KChargedModel.cc;
+svn add      electromagnetic/highenergy/src/G4eeTo3PiModel.cc;
+svn add      electromagnetic/highenergy/src/G4hBremsstrahlungModel.cc;
+svn add      electromagnetic/highenergy/src/G4hPairProductionModel.cc;
+svn add      electromagnetic/lowenergy/include/G4IonParametrisedLossModel.icc;
+svn add      electromagnetic/lowenergy/include/G4IonParametrisedLossTable.icc;
+svn add      electromagnetic/lowenergy/src/G4CrossSectionElasticChampion.cc;
+svn add      electromagnetic/lowenergy/src/G4DNAScreenedRutherfordElasticModel.cc;
+svn add      electromagnetic/lowenergy/src/G4DNAElastic.cc;
+svn add      electromagnetic/lowenergy/src/G4LivermoreRayleighModel.cc;
+svn add      electromagnetic/lowenergy/src/G4PenelopeRayleighModel.cc;
+svn add      electromagnetic/lowenergy/src/G4PenelopeAnnihilationModel.cc;
+svn add      electromagnetic/lowenergy/src/G4RayleighScattering.cc;
+svn add      electromagnetic/lowenergy/src/G4DNADingfelderChargeIncreaseModel.cc;
+svn add      electromagnetic/lowenergy/src/G4DNAEmfietzoglouExcitationModel.cc;
+svn add      electromagnetic/lowenergy/src/G4DNAChampionElasticModel.cc;
+svn add      electromagnetic/lowenergy/src/G4IonParametrisedLossModel.cc;
+svn add      electromagnetic/lowenergy/src/G4PaulKCrossSection.cc;
+svn add      electromagnetic/lowenergy/src/G4PenelopePhotoElectricModel.cc;
+svn add      electromagnetic/lowenergy/src/G4PenelopeComptonModel.cc;
+svn add      electromagnetic/lowenergy/src/G4LivermorePolarizedComptonModel.cc;
+svn add      electromagnetic/lowenergy/src/G4DNABornIonisationModel.cc;
+svn add      electromagnetic/lowenergy/src/G4DNAMillerGreenExcitationModel.cc;
+svn add      electromagnetic/lowenergy/src/G4LivermorePhotoElectricModel.cc;
+svn add      electromagnetic/lowenergy/src/G4CrossSectionElasticScreenedRutherfordHE.cc;
+svn add      electromagnetic/lowenergy/src/G4CrossSectionElasticScreenedRutherfordLE.cc;
+svn add      electromagnetic/lowenergy/src/G4OrlicLCrossSection.cc;
+svn add      electromagnetic/lowenergy/src/G4DNAExcitation.cc;
+svn add      electromagnetic/lowenergy/src/G4PenelopeGammaConversionModel.cc;
+svn add      electromagnetic/lowenergy/src/G4CrossSectionChargeTransferCH.cc;
+svn add      electromagnetic/lowenergy/src/G4CrossSectionPsCreationChampion.cc;
+svn add      electromagnetic/lowenergy/src/G4ecpssrCrossSection.cc;
+svn add      electromagnetic/lowenergy/src/G4DNARuddIonisationModel.cc;
+svn add      electromagnetic/lowenergy/src/G4CrossSectionPsCreationChampionPartial.cc;
+svn add      electromagnetic/lowenergy/src/G4DNAChargeDecrease.cc;
+svn add      electromagnetic/lowenergy/src/G4LivermoreComptonModel.cc;
+svn add      electromagnetic/lowenergy/src/G4FinalStatePsCreationChampion.cc;
+svn add      electromagnetic/lowenergy/src/G4PenelopeBremsstrahlungModel.cc;
+svn add      electromagnetic/lowenergy/src/G4FinalStateElasticChampion.cc;
+svn add      electromagnetic/lowenergy/src/G4PenelopeIonisationModel.cc;
+svn add      electromagnetic/lowenergy/src/G4DNABornExcitationModel.cc;
+svn add      electromagnetic/lowenergy/src/G4LivermoreGammaConversionModel.cc;
+svn add      electromagnetic/lowenergy/src/G4DNAIonisation.cc;
+svn add      electromagnetic/lowenergy/src/G4CrossSectionChargeTransferExp.cc;
+svn add      electromagnetic/lowenergy/src/G4FinalStateChargeTransferProton.cc;
+svn add      electromagnetic/lowenergy/src/G4PenelopeComptonModel.cc;
+svn add      electromagnetic/lowenergy/src/G4LivermorePolarizedComptonModel.cc;
+svn add      electromagnetic/lowenergy/src/G4DNABornIonisationModel.cc;
+svn add      electromagnetic/lowenergy/src/G4DNAMillerGreenExcitationModel.cc;
+svn add      electromagnetic/lowenergy/src/G4LivermorePhotoElectricModel.cc;
+svn add      electromagnetic/lowenergy/src/G4CrossSectionElasticScreenedRutherfordHE.cc;
+svn add      electromagnetic/lowenergy/src/G4CrossSectionElasticScreenedRutherfordLE.cc;
+svn add      electromagnetic/lowenergy/src/G4OrlicLCrossSection.cc;
+svn add      electromagnetic/lowenergy/src/G4DNAExcitation.cc;
+svn add      electromagnetic/lowenergy/src/G4PenelopeGammaConversionModel.cc;
+svn add      electromagnetic/lowenergy/src/G4CrossSectionChargeTransferCH.cc;
+svn add      electromagnetic/lowenergy/src/G4CrossSectionPsCreationChampion.cc;
+svn add      electromagnetic/lowenergy/src/G4ecpssrCrossSection.cc;
+svn add      electromagnetic/lowenergy/src/G4DNARuddIonisationModel.cc;
+svn add      electromagnetic/lowenergy/src/G4CrossSectionPsCreationChampionPartial.cc;
+svn add      electromagnetic/lowenergy/src/G4DNAChargeDecrease.cc;
+svn add      electromagnetic/lowenergy/src/G4LivermoreComptonModel.cc;
+svn add      electromagnetic/lowenergy/src/G4FinalStatePsCreationChampion.cc;
+svn add      electromagnetic/lowenergy/src/G4PenelopeBremsstrahlungModel.cc;
+svn add      electromagnetic/lowenergy/src/G4FinalStateElasticChampion.cc;
+svn add      electromagnetic/lowenergy/src/G4PenelopeIonisationModel.cc;
+svn add      electromagnetic/lowenergy/src/G4DNABornExcitationModel.cc;
+svn add      electromagnetic/lowenergy/src/G4LivermoreGammaConversionModel.cc;
+svn add      electromagnetic/lowenergy/src/G4DNAIonisation.cc;
+svn add      electromagnetic/lowenergy/src/G4CrossSectionChargeTransferExp.cc;
+svn add      electromagnetic/lowenergy/src/G4FinalStateChargeTransferProton.cc;
+svn add      electromagnetic/lowenergy/src/G4DopplerProfile.cc;
+svn add      electromagnetic/lowenergy/src/G4DNADingfelderChargeDecreaseModel.cc;
+svn add      electromagnetic/lowenergy/src/G4LivermoreIonisationModel.cc;
+svn add      electromagnetic/lowenergy/src/G4LivermorePolarizedRayleighModel.cc;
+svn add      electromagnetic/lowenergy/src/G4DNAChargeIncrease.cc;
+svn add      hadronic/cross_sections/src/G4GGNuclNuclCrossSection.cc;
+svn add      hadronic/cross_sections/src/G4CrossSectionDataSetRegistry.cc;
+svn add      hadronic/models/neutron_hp/src/G4NeutronHPFinalState.cc;
+svn add      hadronic/models/incl/src/G4AblaFission.cc;
+svn add      hadronic/models/incl/src/G4Ranecu.cc;
+svn add      hadronic/models/incl/src/G4AblaFissionSimfis18.cc;
+svn add      hadronic/models/rpg/src/G4RPGPionInelastic.cc;
+svn add      hadronic/models/rpg/src/G4RPGNucleonInelastic.cc;
+svn add      hadronic/models/parton_string/diffraction/src/G4FTFParameters.cc;
+svn add      hadronic/models/parton_string/diffraction/src/G4ElasticHNScattering.cc;
+svn add      hadronic/models/pre_equilibrium/exciton_model/src/G4PreCompoundAlpha.cc;
+svn add      hadronic/models/pre_equilibrium/exciton_model/src/G4PreCompoundHe3.cc;
+svn add      hadronic/models/pre_equilibrium/exciton_model/src/G4PreCompoundDeuteron.cc;
+svn add      hadronic/models/pre_equilibrium/exciton_model/src/G4PreCompoundNeutron.cc;
+svn add      hadronic/models/pre_equilibrium/exciton_model/src/G4PreCompoundTriton.cc;
+svn add      hadronic/models/pre_equilibrium/exciton_model/src/G4PreCompoundProton.cc;
+svn add      hadronic/models/chiral_inv_phase_space/interface/src/G4QIonIonElastic.cc;
+svn add      hadronic/models/chiral_inv_phase_space/interface/src/G4GammaNuclearReaction.cc;
+svn add      hadronic/models/chiral_inv_phase_space/calcul/G4NuMuXQ2Integration_N.cc;
+svn add      hadronic/models/chiral_inv_phase_space/calcul/G4BoundMuDecInElIntegration.cc;
+svn add      hadronic/models/chiral_inv_phase_space/calcul/G4NuElXQ2Integration.cc;
+svn add      hadronic/models/chiral_inv_phase_space/calcul/G4SurfaceCalculation.cc;
+svn add      hadronic/models/chiral_inv_phase_space/calcul/G4NuElXQ2Integration_N.cc;
+svn add      hadronic/models/chiral_inv_phase_space/calcul/G4MultyFragmentationTest.cc;
+svn add      hadronic/management/src/G4HadronicProcessStore.cc;
+svn add      cuts/src/G4ProductionCutsTableMessenger.cc;