Index: trunk/source/interfaces/common/include/G4Qt.hh
===================================================================
--- trunk/source/interfaces/common/include/G4Qt.hh	(revision 883)
+++ trunk/source/interfaces/common/include/G4Qt.hh	(revision 989)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Qt.hh,v 1.4 2008/11/06 10:06:33 lgarnier Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 //  To unify Qt event treatment between 
Index: trunk/source/interfaces/common/include/G4VBasicShell.hh
===================================================================
--- trunk/source/interfaces/common/include/G4VBasicShell.hh	(revision 883)
+++ trunk/source/interfaces/common/include/G4VBasicShell.hh	(revision 989)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VBasicShell.hh,v 1.7 2006/06/29 19:10:03 gunter Exp $
-// GEANT4 tag $Name: HEAD $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 
Index: trunk/source/interfaces/common/include/G4VInteractorManager.hh
===================================================================
--- trunk/source/interfaces/common/include/G4VInteractorManager.hh	(revision 883)
+++ trunk/source/interfaces/common/include/G4VInteractorManager.hh	(revision 989)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VInteractorManager.hh,v 1.9 2006/06/29 19:10:08 gunter Exp $
-// GEANT4 tag $Name: HEAD $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 // G.Barrand
Index: trunk/source/interfaces/common/include/G4Wt.hh
===================================================================
--- trunk/source/interfaces/common/include/G4Wt.hh	(revision 989)
+++ trunk/source/interfaces/common/include/G4Wt.hh	(revision 989)
@@ -0,0 +1,70 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+//
+// $Id: G4Wt.hh,v 1.2 2007/11/08 17:00:09 lgarnier Exp $
+// GEANT4 tag $Name: HEAD $
+//
+//  To unify Wt event treatment between 
+// G4/interfaces Wt sessions and G4/visualizations Wt drivers.
+// L. Garnier
+#ifndef G4WT_HH
+#define G4WT_HH
+
+//#define G4INTY_BUILD_WT
+
+#if defined(G4INTY_BUILD_WT) || defined(G4INTY_USE_WT)
+
+#include "G4VInteractorManager.hh"
+
+namespace Wt {
+  class WEnvironment;  
+}
+
+// Class description :
+//
+//  G4Wt : a singleton to handle GUI sessions and visualization 
+// drivers built over Wt. It permits to have one Wt main loop for 
+// the whole application. The Wt toolkit is inited in the 
+// constructor. It is done once for the whole application.
+//
+// Class description - end :
+
+class G4Wt : public G4VInteractorManager {
+public:
+  static G4Wt* getInstance();
+  static G4Wt* getInstance(const Wt::WEnvironment&);
+  G4bool Inited();
+  void* GetEvent();
+  void FlushAndWaitExecution();
+  virtual ~G4Wt();                     
+private:
+  G4Wt (const Wt::WEnvironment&);                     
+  static G4Wt* instance; // Pointer to single instance.
+};
+
+#endif //HAS_WT
+
+#endif
Index: trunk/source/interfaces/common/include/G4Xt.hh
===================================================================
--- trunk/source/interfaces/common/include/G4Xt.hh	(revision 883)
+++ trunk/source/interfaces/common/include/G4Xt.hh	(revision 989)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Xt.hh,v 1.6 2006/06/29 19:10:14 gunter Exp $
-// GEANT4 tag $Name: HEAD $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 //  To unify X11 event treatment between 